package simulateur;

import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;
import java.util.*;


public class graphCanvas extends Canvas implements MouseListener {
	
    Dimension tailleImage;
    private Graphics offg;
    private Image offImage = null;
    RenderingThread tr = new RenderingThread();
    public static boolean tracerEnCours;
    public static int xTrace;
    public Vector croixX, croixY;
    public int yDebut = 30;
    public Vector traceCourbe = new Vector();
    private Simulateur app;
    public boolean newPortion = false;
    public int periode, amplitudeTr;
    public static int nbPeriode, nbClic;
    public Random hasard = new Random();
    public boolean zoomX10 = false;
    public double masseEtoile, luminositeEtoile, rayEtoile, magnitudeK;
    protected DecimalFormat df1 = new DecimalFormat("#######0.0");
    protected DecimalFormat df2 = new DecimalFormat("#######0.00");
    protected DecimalFormat df3 = new DecimalFormat("#######0.000");

    
    /** constructeur **/
    public graphCanvas(int i, int j, String massEtoile, String lumEtoile, String rayonEtoile, String magK, Simulateur app) {
        this.app = app;
        this.masseEtoile = (massEtoile == "??") ? 0 : Double.valueOf(massEtoile).doubleValue(); 
        this.luminositeEtoile =	(lumEtoile == "??") ? 0 : Double.valueOf(lumEtoile).doubleValue(); 
        this.rayEtoile = (rayonEtoile == "??") ? 0 : Double.valueOf(rayonEtoile).doubleValue(); 
        this.magnitudeK = Double.valueOf(magK).doubleValue();
        if (rayEtoile>600000) zoomX10 = true;
        if (magnitudeK>12) amplitudeTr = 4;
    	else if (magnitudeK>9) amplitudeTr = 3;
    	else amplitudeTr = 2;        
    	periode = 110 + (int)(Math.random()*80.0);
        xTrace = 50;
        croixX = new Vector();
        croixY = new Vector();
        tailleImage = new Dimension(i, j);
        offImage = app.createImage(i, j);
        constructionCourbe();
        addMouseListener(this);
        tracerEnCours = true;
        tr.start();
    }

    public Dimension getPreferredSize() {
        return tailleImage;
    }

    public Dimension getMinimumSize() {
        return tailleImage;
    }

    public void paint(Graphics gp) {
    	if (offImage != null) {
    		offg = offImage.getGraphics();
    		offg.setFont(new Font(getFont().getName(), 0, 12));
        	Dimension dimension = getSize();
        	int i = (dimension.width - tailleImage.width) / 2;
        	int j = (dimension.height - tailleImage.height) / 2;
        	offg.setColor(new Color(228,226,224));
        	offg.fillRect(i, j, tailleImage.width-1, tailleImage.height-1);
        	offg.setColor(Color.black);
        	offg.drawRect(i, j, tailleImage.width-1, tailleImage.height-1);
        	tracerEchelle(offg);
        	if (newPortion || !tr.isAlive()) { 
        	    boolean relance = false;
        		if (tr.isAlive()) {
        			tr.suspend();
        			relance = true;
        		}
        		offg.setColor(new Color(150,98,42));
        		int precedent = yDebut;
        		for(int k = 0; k < xTrace; k++) {
            		int val = Integer.parseInt((String)traceCourbe.elementAt(k));
            		offg.drawLine(k+51,precedent,k+52,val);
            		precedent = val;
                }
        		if (relance) tr.resume();
        		newPortion = false;
        	}
        	if (!tracerEnCours) {
        		offg.setColor(new Color(122,113,104));
        		offg.drawString(Messages.get("Les") + " " + nbPeriode + " " + Messages.get("pertes"),80,140);
        		offg.drawString(Messages.get("vidence"),80,160);
        		offg.drawString(Messages.get("slectionn"),80,180);
        		if ((nbPeriode-nbClic)!=0) {
        			offg.setColor(Color.red);
            		offg.drawString(Messages.get("Cliquez_pointe"),80,200);
            		offg.drawString(Messages.get("afin_tablir"),80,220);
        			app.txtGraph4.setForeground(Color.red);
        			app.txtGraph4.setAlignment(1);
        			app.txtGraph4.setText(Messages.get("il_reste") + " " + (nbPeriode-nbClic) + " " + Messages.get("transits__identifier"));
        		}		
        	}        	
        	if (croixX.size()>0) dessinerCroix(offg);
        	gp.drawImage(offImage, 0, 0, this);
    	}	
    }
    

    /** trace echelle + valeurs du graphe **/
    public void tracerEchelle(Graphics gp) {
        FontMetrics fm11 = getFontMetrics(new Font(getFont().getName(), 1, 11));
        offg.setFont(new Font(getFont().getName(), 1, 11));
    	gp.setColor(new Color(166,159,152));
    	gp.drawLine(50,15,50,280);
    	gp.drawLine(50,15,47,19);
    	gp.drawLine(50,15,53,19);
    	gp.drawLine(50,280,530,280);
    	gp.drawLine(530,280,526,277);
    	gp.drawLine(530,280,526,283);
    	gp.drawString(Messages.get("Luminosit_normalis"),10,13);
    	gp.drawString(Messages.get("Jours"),515,295);
    	for (int i=0; i<450 ;i=i+100) {
    		gp.drawLine(50+i,280,50+i,282);
    		int deplacement = (int)(fm11.stringWidth(String.valueOf(i))/2);
    		gp.drawString(String.valueOf(i),50+i-deplacement,295);
    	}
   		gp.drawLine(50,yDebut,48,yDebut);
   		gp.drawString("1",37,yDebut+5);
   		gp.drawLine(50,280,48,280);
   		int ord1 = ((int)((280-yDebut)/2)) + yDebut;
   		gp.drawLine(50,ord1,48,ord1);
   		if (zoomX10) { 
   			gp.drawString("95%",24,ord1+5);
   			gp.drawString("90%",24,285);
   		}
   		else { 
   			gp.drawString("50%",24,ord1+5);
   			gp.drawString("0",37,285);
   		}
    	offg.setFont(new Font(getFont().getName(), 0, 12));
    }
    
 
    /** relance affichage du graph **/
    public void relancerGraph() {
    	constructionCourbe();
    	croixX.removeAllElements();
    	croixY.removeAllElements();
    	xTrace = 50;
    	tr = new RenderingThread();
    	app.relGraph.disable();
    	app.retourCarte.disable();
    	app.retourCaractEtoile.disable();
		app.txtGraph4.setForeground(new Color(230, 221, 212));
		app.txtGraph2.setText("");
		app.txtGraph3.setText("");
		app.txtGraph4.setText("");
		app.txtGraph5.setText("");
		app.txtGraph6.setText("");
		app.txtGraph7.setText("");
		app.txtGraph8.setText("");
    	tracerEnCours = true;
        tr.start();
    }

    public void update(Graphics gp) {
        paint(gp);
    }
    
    
    /** genere valeurs de la courbe aleatoire **/
    public void constructionCourbe() {
    	traceCourbe.removeAllElements();
    	nbPeriode = 0;
    	nbClic = 0;
    	int transit;
    	int tempo1 = 500%periode;
    	if (tempo1<4) tempo1 = 4;
    	int tempo2 = hasard.nextInt((int)(tempo1/4));
    	if (hasard.nextDouble()>0.5) tempo2 = -tempo2;
    	if (tempo1>20) transit = (int)(tempo1/2) + tempo2;
    	else transit = 15 +  hasard.nextInt(10);
    	int val = yDebut;
    	boolean descendant = false;
        for(int k = 0; k < 500; k++) {
        	if ((k+2)==transit && (k+2)<500) {
        		nbPeriode++;
        		transit+=periode; 
        		traceCourbe.addElement(Integer.toString(yDebut));
        		traceCourbe.addElement(Integer.toString(yDebut+amplitudeTr));
        		traceCourbe.addElement(Integer.toString(yDebut+5*amplitudeTr));
        		traceCourbe.addElement(Integer.toString(yDebut+amplitudeTr));
        		traceCourbe.addElement(Integer.toString(yDebut));
        		k+=4;
        	} else {
        		// courbe trop cassante si dfini hasard une seule fois
        		if (hasard.nextDouble()>0.85) val = amplitudeTr+1;
        		else if (hasard.nextDouble()>0.76) val = amplitudeTr;
        		else if (hasard.nextDouble()>0.66) val = 2;
        		else if (hasard.nextDouble()>0.55) val = 1;
        		else if (hasard.nextDouble()>0.45) val = 0;
        		else if (hasard.nextDouble()>0.33) val = -1;
        		else if (hasard.nextDouble()>0.24) val = -2;
        		else if (hasard.nextDouble()>0.15) val = -amplitudeTr;
        		else val = -amplitudeTr-1;
        		traceCourbe.addElement(Integer.toString(val+yDebut));
        	}
        }
    }
    
    
    /** active affichage courbe **/
    public void affichageCourbe() {
    	newPortion = true;
    	repaint();	
    }
    
    
    /** dessine croix + fleche lors d'un clic sur le graph **/
    public void dessinerCroix (Graphics g) {
        g.setColor(Color.red);
        for (int i=0; i<croixX.size(); i++) {
        	int valX = Integer.valueOf((String)croixX.get(i)).intValue();
        	int valY = Integer.valueOf((String)croixY.get(i)).intValue();
        	g.drawLine(valX-2, valY-2, valX+2, valY+2);
            g.drawLine(valX-2, valY+2, valX+2, valY-2);
            g.drawLine(valX , valY+5, valX, valY+15);
            g.drawLine(valX-1 , valY+6, valX-1, valY+15);
            g.drawLine(valX+1 , valY+6, valX+1, valY+15);
            g.drawLine(valX-2 , valY+7, valX+2, valY+7);
            g.drawLine(valX-3 , valY+8, valX+3, valY+8);
        }
        g.setColor(Color.black);
    }

    
    /** affichage du resultat lorsque les x releves ont ete faits **/
    public void activationResultat() {
		double periodeMoyenne, profondeurMoyenne;
		boolean bonnePrecision = true;
		int[] abscPoint = new int[croixX.size()];
		int[] ordoPoint = new int[croixY.size()];
		for (int i=0; i<croixX.size(); i++) {
        	int valX = Integer.valueOf((String)croixX.get(i)).intValue();
        	int valY = Integer.valueOf((String)croixY.get(i)).intValue();
        	abscPoint[i] = valX;
        	ordoPoint[i] = valY;
		}
		Arrays.sort(abscPoint);
		Arrays.sort(ordoPoint);
		double tempoPeriode = 0;
		double tempoProfondeur = 0;
		for (int i=0; i<(abscPoint.length-1); i++) {
			tempoPeriode += abscPoint[i+1]-abscPoint[i];
			if (((double)Math.abs(periode-abscPoint[i+1]+abscPoint[i])/(double)periode)>=0.05) bonnePrecision = false;
		}
		periodeMoyenne = Math.rint(tempoPeriode/(abscPoint.length-1));
		if (((double)Math.abs(periode-periodeMoyenne)/(double)periode)>=0.05) bonnePrecision = false;
		for (int i=0; i<=(ordoPoint.length-1); i++) {
			tempoProfondeur += (double)((double)(ordoPoint[i]-yDebut)/2.5);
			if (((double)Math.abs(ordoPoint[i]-yDebut-amplitudeTr*5))>=6.0) bonnePrecision = false;
		}
		profondeurMoyenne = (tempoProfondeur/(double)ordoPoint.length);
		if (zoomX10) profondeurMoyenne = profondeurMoyenne/10.0;
		if (bonnePrecision) {
			app.txtGraph2.setForeground(Color.black);
			app.txtGraph2.setText(Messages.get("Les") + " " + nbPeriode + " " + Messages.get("repres_permettent"));
			app.txtGraph3.setForeground(new Color(141,119,95));
			app.txtGraph3.setText(Messages.get("priode_environ") + " " + (int)periodeMoyenne + " " + Messages.get("jours_et_profondeur") + " " + df2.format(profondeurMoyenne) + " %");
			app.txtGraph4.setAlignment(0);
			app.txtGraph4.setForeground(Color.black);
			app.txtGraph4.setText(Messages.get("donnes_combines"));
			app.txtGraph5.setAlignment(0);
			app.txtGraph5.setForeground(Color.black);
			app.txtGraph5.setText(Messages.get("permettent_extrapoler"));
			app.txtGraph6.setForeground(new Color(141,119,95));
			String thisOrbite = (masseEtoile == 0) ? "??" : df3.format(masseEtoile * Math.pow(((double)periodeMoyenne/(double)365),(double)2/3));
			app.txtGraph6.setText("   - " + Messages.get("son_orbite") + " " + thisOrbite + " " + Messages.get("UA"));
			app.txtGraph7.setForeground(new Color(141,119,95));
			String thisLum = (luminositeEtoile == 0) ? "??" : df2.format(300 * Math.pow((luminositeEtoile/Math.pow(masseEtoile * Math.pow(((double)periodeMoyenne/(double)365),(double)2/3),2)),(double)1/4));
			app.txtGraph7.setText("   - " + Messages.get("sa_temprature") + " " + thisLum + " " + Messages.get("Kelvin"));
			app.txtGraph8.setForeground(new Color(141,119,95));
			String thisRay = (rayEtoile == 0) ? "??" : df2.format(rayEtoile * Math.sqrt(profondeurMoyenne/100.0));
			app.txtGraph8.setText("   - " + Messages.get("son_rayon") + " " + thisRay + " " + Messages.get("Km"));			
		} else {
	    	app.txtGraph4.setForeground(Color.red);
			app.txtGraph4.setText(Messages.get("mesure_imprcise"));
			app.txtGraph5.setForeground(Color.red);
			app.txtGraph5.setAlignment(1);
			app.txtGraph5.setText(Messages.get("graphe_et_cliquez") + " " + nbPeriode + " " + Messages.get("principaux_pics"));
		}
    }
    
    /** clic sur le graph **/
    public void mouseClicked(MouseEvent e) {
    	if (!tracerEnCours && (nbPeriode-nbClic)>0) {
            croixX.addElement(Integer.toString(e.getX()));
            croixY.addElement(Integer.toString(e.getY()));
            nbClic++;
    		repaint();
    	}
    	if ((nbPeriode-nbClic)==0) {
    		activationResultat();
    	}
    }    
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mouseDragged(MouseEvent e) {
    }
    
    public void mouseMoved(MouseEvent e) {
    }
    
    
    class RenderingThread extends Thread {
    	public void run(){
    		while(tracerEnCours){
               try {
               	if (xTrace >= 500) { 
               		tracerEnCours = false;
               		app.relGraph.enable();
                	app.retourCarte.enable();
                	app.retourCaractEtoile.enable();
               		app.txtGraph1.setForeground(Color.gray);
               		app.txtGraph1.setText("   " + Messages.get("Relancez_graphique"));
               	}
               	else {
               		if (xTrace<75) {
                   		app.txtGraph1.setForeground(new Color(230, 221, 212));
               			app.txtGraph1.setText("   " + Messages.get("Relancez_graphique"));
               		} else {
               			app.txtGraph1.setForeground(Color.red);
               		}
               		xTrace++;
               		if (xTrace%25==0) app.txtGraph1.setText(Messages.get("Trac_en_cours"));
               		if (xTrace%50==0) app.txtGraph1.setText("");
               	}
                sleep(10);
                affichageCourbe();
               } catch ( Exception e ) {} 
            }
         }
      }
	
}
